<%@ Page Language="C#" %>
<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.Data.SqlClient" %>
<%@ Import Namespace="System.Net.Mail" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<script runat="server">

    protected void btnRegister_Click(object sender, EventArgs e)
    {
        SqlConnection con = new SqlConnection(Database.ConnectionString);
        SqlTransaction trans =null;
        try
        {
            con.Open();
            trans = con.BeginTransaction(); 
            SqlCommand cmd = new SqlCommand("select uname from contractors where uname=@uname", con);
            cmd.Transaction = trans; 
            cmd.Parameters.Add("@uname", SqlDbType.VarChar, 10).Value = txtUname.Text;
            Object value = cmd.ExecuteScalar();
            if (value != null)
            {
                lblMsg.Text = "Username is already existing. Please Try Another Usename!";
                return;
            }

            cmd.CommandText = "select email from contractors where email=@email";
            cmd.Parameters.Add("@email", SqlDbType.VarChar, 30).Value = txtEmail.Text;
            value = cmd.ExecuteScalar();
            if (value != null)
            {
                lblMsg.Text = "Email Address is already existing. Please Try Another Address!";
                return;
            }  
            
            // generate password
            String pwd = new Random().Next(1000, 9999).ToString();
                         
            // insert row into contractors

            cmd.CommandText = "insert into contractors values(@uname,@pwd,@cname,@email,@exp,@hintq,@hinta)";
            cmd.Parameters.Add("@pwd", SqlDbType.VarChar, 10).Value = pwd;
            cmd.Parameters.Add("@cname", SqlDbType.VarChar, 30).Value = txtCName.Text;
            cmd.Parameters.Add("@exp", SqlDbType.VarChar, 1000).Value = txtExp.Text;
            cmd.Parameters.Add("@hintq", SqlDbType.VarChar, 100).Value = txtHintQ.Text;
            cmd.Parameters.Add("@hinta", SqlDbType.VarChar, 100).Value = txtHintAns.Text;
            cmd.ExecuteNonQuery(); 
           
            // send mail with password      

            MailMessage m = new MailMessage();
            m.From =  new MailAddress("admin@classroom.com");
            m.To.Add(new MailAddress (txtEmail.Text));
            m.Subject = "Welcome To Online Tenders";
            m.IsBodyHtml = true;
            m.Body = "Dear " + txtUname.Text + ",<br> Welcome to Online Tenders Application. <p/>Use the following details to login.<p> Uname : " + txtUname.Text + "<br>Password :" + pwd + "<p>Admin,<br>OnlineTenders.Com";

            SmtpClient server = new SmtpClient("classroom");
            server.Send(m);
            lblMsg.Text = "Registration Completed.<br>A mail has been sent to your email address with password. Please use that password to login. <p>Thank you for using this site.";
            trans.Commit();
        }
        catch (Exception ex)
        {
            lblMsg.Text = "Error-->" + ex.Message;
            trans.Rollback();
        }
        finally
        {
            con.Close();
        }
        

    }
</script>

<html xmlns="http://www.w3.org/1999/xhtml" >
<head runat="server">
    <title>Untitled Page</title>
</head>
<body>
    <form id="form1" runat="server">
    <div>
        <br />
        <h2>
        New User Registeration</h2>
        <table>
            <tr>
                <td style="width: 159px">
                    User Name :
                </td>
                <td style="width: 34px">
                    <asp:TextBox ID="txtUname" runat="server" Width="94px"></asp:TextBox>&nbsp;</td>
            </tr>
            <tr>
                <td style="width: 159px; height: 26px;">
                    Contractor Name :
                </td>
                <td style="width: 34px; height: 26px;">
                    <asp:TextBox ID="txtCName" runat="server" Width="231px"></asp:TextBox></td>
            </tr>
            <tr>
                <td style="width: 159px; height: 26px;">
                    Email Address :
                </td>
                <td style="width: 34px; height: 26px;">
                    <asp:TextBox ID="txtEmail" runat="server" Width="231px"></asp:TextBox></td>
            </tr>
            <tr>
                <td style="width: 159px; height: 61px" valign="top">
                    Experience :
                </td>
                <td style="width: 34px; height: 61px">
                    <asp:TextBox ID="txtExp" runat="server" Height="63px" Width="231px"></asp:TextBox></td>
            </tr>
            <tr>
                <td style="width: 159px">
                    Hint Question :
                </td>
                <td style="width: 34px">
                    <asp:TextBox ID="txtHintQ" runat="server" Width="231px"></asp:TextBox></td>
            </tr>
           <tr>
          <td style="width: 159px">Hint Answer :
          </td>
         <td style="width: 34px">
             <asp:TextBox ID="txtHintAns" runat="server" Width="231px"></asp:TextBox></td> 
           </tr> 
        </table>
        <br />
        <asp:Button ID="btnRegister" runat="server" Text="Register" OnClick="btnRegister_Click" /><br />
        <br />
        <br />
        <asp:Label ID="lblMsg" runat="server" Font-Bold="True"></asp:Label></div>
    </form>
</body>
</html>
